/*
 * Copyright (C) 1999 Silicon Graphics, Inc.  All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  Further, any license provided herein,
 * whether implied or otherwise, is limited to this program in accordance
 * with the express provisions of the GNU General Public License.  Patent
 * licenses, if any, provided herein do not apply to combinations of this
 * program with other product or programs, or any other product whatsoever.
 * This program is distributed without any warranty that the program is
 * delivered free of the rightful claim of any third person by way of
 * infringement or the like.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 */

#ifndef	RSH_SERVICES_H
#define	RSH_SERVICES_H

#include <stdio.h>
#include "node.h"

extern void	rshHandlePSMessage(InputEntry *entry,gpointer clientData);

class RSHservices : public NodeServices {
private:
	char	*ps_search;
public:
	RSHservices()			{ /* BOGUS!!!!! */		}
	RSHservices(Node *p)		{ parent = p; ps_search = NULL;	}
	char	*typeName()		{ return("RSH node services");	}
	void	setPSSearch(char *s)	{ ps_search = strdup(s);	}
	char	*getPSSearch()		{ return(ps_search);		}
	void doNodeConfigure(InputEntryProc func,char *nodeid,char * /*device*/,
			     char * /*pw*/,char *addr) {
                sprintf(msgPacket,"rsh:CONFIGURATION:%s:%s:",nodeid,addr);
                sendMsg(msgPacket,TRUE,func,(gpointer) parent);
		if (addr != NULL) {
			sprintf(msgPacket,"nexxus:set_var:%s:ip_address:%s:",
				nodeid,addr);
			sendMsg(msgPacket,TRUE,NULL,(gpointer) parent);
		}
	}
	void doMachineStatus(InputEntryProc func) {
                sprintf(msgPacket,"rsh:CHASSIS_STATUS:%s:",parent->name);
                if (parent->connection->handle != NULL) {
                        (void) sendMsg(msgPacket,TRUE,func,(gpointer) parent);
		}
		/*
		 *	If there is a process watch on, this is the
		 *	time to do it.
		 */
		if (getPSSearch()) {
			sprintf(msgPacket,"rsh:PS:%s:%s:",parent->name,
				getPSSearch());
			if (parent->connection->handle != NULL) {
				(void) sendMsg(msgPacket,TRUE,rshHandlePSMessage,
					       (gpointer) parent);
			}
		}
	}
	void doNodeInventory(InputEntryProc func) {
		sprintf(msgPacket,"rsh:NODE_INV_INFO:%s:",parent->name);
		(void) sendMsg(msgPacket,TRUE,func,(gpointer) parent);
	}
	void doNodeInquiry(InputEntryProc func) {
		sprintf(msgPacket,"rsh:INQUIRY:%s:",parent->name);
		(void) sendMsg(msgPacket,TRUE,func,(gpointer) parent);
	}
	void getSENThresholds(char * /*sensor*/,gpointer /*panel*/,InputEntryProc /*func*/) {}
	void doSENLogging(gpointer /*panel*/,InputEntryProc /*func*/) {}
	void doSELLogging(gpointer panel,InputEntryProc func) {
		sprintf(msgPacket,"rsh:DOWNLOAD_LOG:%s:",parent->name);
		if (parent->connection->handle != NULL) {
			(void) sendMsg(msgPacket,TRUE,func,panel);
		}
	}
	void doReset()	{}
	void doPowerUp() {}
	void doPowerDown() {}
	void doStimulateSELEntry(int /*n*/) {}
	void doSetNodeType() {}
	void doConsoleConfigure(gpointer /*panel*/,InputEntryProc /*func*/) {}
	void doConsoleActivate(gpointer panel,InputEntryProc func) {
		InputEntry *tmp = (InputEntry *) malloc(sizeof(InputEntry));
		char	buf[128];

		tmp->jobnum = 0;
		sprintf(buf,"CONNECT:bogus:%s:::",parent->ip);
		tmp->string = buf;
		tmp->next = NULL;
		func(tmp,panel);
	}
        void doConsoleDisconnect() {}
	void doConsoleAlerts(gpointer /*panel*/,InputEntryProc /*func*/) {}
	void handleInventoryMessage(InputEntry * /*entry*/);
	void handleInquiryMessage(InputEntry * /*entry*/);
};

#endif	/*RSH_SERVICES_H*/
