/*
 * Copyright (C) 1999 Silicon Graphics, Inc.  All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  Further, any license provided herein,
 * whether implied or otherwise, is limited to this program in accordance
 * with the express provisions of the GNU General Public License.  Patent
 * licenses, if any, provided herein do not apply to combinations of this
 * program with other product or programs, or any other product whatsoever.
 * This program is distributed without any warranty that the program is
 * delivered free of the rightful claim of any third person by way of
 * infringement or the like.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 */

#ifndef	VASHHANDLE_H
#define	VASHHANDLE_H
#include <gtk/gtk.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "VashPanel.h"

extern "C" {
#include <sys/types.h>
#include <sys/wait.h>
}

class VashHandle {
protected:
	FILE *_inputfp;             // read from child
	FILE *_outputfp;            // write to child
	FILE *_errorfp;             // read errors from child

private:
	VashPanel *theVashPanel;
	pid_t	thePid;
	int	to_child[2];            // pipes
	int	to_parent[2];
	int	to_parent_error[2];

public:
	VashHandle(VashPanel *);
	pid_t	pid()	{ return(thePid);	}
	int start();
	void executeChild();
	int	setupCommunication();
	int	setupChildCommunication();
	int	setupParentCommunication();
	FILE	*errorfp()  const { return _errorfp;  }
	VashPanel	*cmdPanel() { return(theVashPanel); }
	int	writeStr(char *);
};

#endif	/*VASHHANDLE_H*/
