/*
 * Copyright (C) 1999 Silicon Graphics, Inc.  All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  Further, any license provided herein,
 * whether implied or otherwise, is limited to this program in accordance
 * with the express provisions of the GNU General Public License.  Patent
 * licenses, if any, provided herein do not apply to combinations of this
 * program with other product or programs, or any other product whatsoever.
 * This program is distributed without any warranty that the program is
 * delivered free of the rightful claim of any third person by way of
 * infringement or the like.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 */
#ifndef	HOOVER_H
#define	HOOVER_H

#include <gtk/gtk.h>

extern GtkWidget	*theList;
extern gboolean		globalStatusChecksSuspended;
extern gboolean		globalDemoMode;
extern int		globalVerboseMode;

extern GtkWidget	*getIcon(gchar **data);

extern GtkWidget	*hooverGetStatusBar();
extern void		hooverSetStatus(char *msg);
extern void		hooverClearStatus();
extern GtkWidget	*hooverGetProgressBar();
extern void		hooverResetProgressBar();
extern void		hooverNodeSelection(GtkWidget *item, gchar *signame);
extern void		suspendStatusChecks();
extern void		resumeStatusChecks();

typedef enum NodeType_t {
        TYPE_UNKNOWN_NODE,	// bad or unknown type
        TYPE_EMP_NODE,          // Intel EMP/IPMI endowed node
        TYPE_MSC_NODE,          // SGI MSC endowed node
        TYPE_RSH_NODE,          // 'rsh' accessible node
        TYPE_CLUSTER,
        TYPE_ALIAS,             // for cluster node in metacluster
        TYPE_METACLUSTER
} NodeType;

//#define	EMP_ONLY

extern NodeType	nodeTypeFromName(char *nm);
extern char	*nodeNameFromType(NodeType nt);

#endif	/*HOOVER_H*/
