/*
 * Copyright (C) 2000 Silicon Graphics, Inc.  All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  Further, any license provided herein,
 * whether implied or otherwise, is limited to this program in accordance
 * with the express provisions of the GNU General Public License.  Patent
 * licenses, if any, provided herein do not apply to combinations of this
 * program with other product or programs, or any other product whatsoever.
 * This program is distributed without any warranty that the program is
 * delivered free of the rightful claim of any third person by way of
 * infringement or the like.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 */
/*
 * Author:      Dean Johnson (dtj@sgi.com)
 *
 */

#ifndef GENERICTEXTPANEL_H
#define GENERICTEXTPANEL_H

#include "PanelContainer.h"

class GenericTextPanel: public Panel {
protected:
        int     insertPoint;
public:
        GenericTextPanel(PanelContainer *);
        gchar   *name()                 { return("GenericTextPanel");	}
        gchar   *typeName()             { return("GenericTextPanel");	}
        int     interested(char *,gpointer);
        void    doMenu(GtkWidget *parent);
	void	freeze()	{
		gtk_text_freeze((GtkText *) theContentWidget);
	}
	void	thaw()	{
		gtk_text_thaw((GtkText *) theContentWidget);
	}
        int     getInsertPoint()        { return(insertPoint);  }
        void    setInsertPoint(int pt)  {
                insertPoint = pt;
                gtk_text_set_point((GtkText *) theContentWidget,pt);
        }
	void	appendText(const char *str) {
		gtk_text_insert(GTK_TEXT(theContentWidget),NULL,NULL,NULL,str,
				strlen(str));
		setInsertPoint(getInsertPoint() + strlen(str));
	}
	void	clear() {
		gtk_editable_delete_text((GtkEditable *) theContentWidget,
					 0,gtk_text_get_length(GTK_TEXT(theContentWidget)));
		insertPoint = 0;
	}
};

#endif  /*GENERICTEXTPANEL_H*/
