/*
 * Copyright (C) 2000 Silicon Graphics, Inc.  All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  Further, any license provided herein,
 * whether implied or otherwise, is limited to this program in accordance
 * with the express provisions of the GNU General Public License.  Patent
 * licenses, if any, provided herein do not apply to combinations of this
 * program with other product or programs, or any other product whatsoever.
 * This program is distributed without any warranty that the program is
 * delivered free of the rightful claim of any third person by way of
 * infringement or the like.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 */
/*
 * Author:      Dean Johnson (dtj@sgi.com)
 *
 */

#ifndef GENERICTREEPANEL_H
#define GENERICTREEPANEL_H

#include "PanelContainer.h"

class GenericTreePanel: public Panel {
private:
	GtkWidget	*theTree;
public:
        GenericTreePanel(PanelContainer *);
        gchar   *name()                 { return("GenericTreePanel");	}
        gchar   *typeName()             { return("GenericTreePanel");	}
	void	freeze(void)		{ /* nothing */ 		}
	void	thaw(void)		{ /* nothing */ 		}
	GtkWidget	*getTree()	{ return(theTree);		}
        void    clear() {
                gtk_tree_clear_items((GtkTree *) theContentWidget,0,-1);
        }
	void	append(GtkWidget *w) {
		gtk_tree_append((GtkTree *) theContentWidget,w);
	}
	GtkWidget *appendText(char *txt,gboolean selectable = FALSE);
        int     interested(char *,gpointer);
        void    doMenu(GtkWidget *parent);
};

#endif  /*GENERICTREEPANEL_H*/
