#include <gtk/gtk.h>
#include "Globals.h"
#include <string.h>

extern GtkWidget *gsAddMainMenuItem(char *str);

GtkWidget *
gsInitMainMenus(int cnt,GtkItemFactoryEntry menu_items[])
{
	GtkWidget       *tmp;
	GtkAccelGroup   *acgroup = gtk_accel_group_new();
	GtkItemFactory  *item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR,
							     "<main>",acgroup);
	gtk_item_factory_create_items (item_factory, cnt, menu_items, NULL);
	/* Attach the new accelerator group to the window. */
	gtk_accel_group_attach(acgroup, GTK_OBJECT (theRootWindow));
	tmp = gtk_item_factory_get_widget (item_factory, "<main>");
	gtk_widget_show(tmp);
	return(tmp);
}

int
gsFindMainMenuItemLocation(char *str)
{
	GtkWidget	*item;
	GtkWidget	*item2;
	GList	*children = gtk_container_children((GtkContainer *) theRootMenuBar);
	int     nchildren = g_list_length(children);
	GList   *subchildren;
	char    *cptr;

	if (!str) return(-1);
	for (int i = 0; i < nchildren; i++) {
		item = (GtkWidget *) g_list_nth_data(children,i);
		subchildren = gtk_container_children((GtkContainer *) item);
		item2 = (GtkWidget *) g_list_nth_data(subchildren,0);
		gtk_label_get(GTK_LABEL(item2),&cptr);
		if (!strcmp(str,cptr)) return(i);
	}
	return(-1);
}

GtkWidget *
gsFindMainMenuItemWidget(char *str,gboolean add_if_not_found)
{
	GtkWidget	*item;
	GtkWidget	*item2;
	GList	*children = gtk_container_children((GtkContainer *) theRootMenuBar);
	int     nchildren = g_list_length(children);
	GList   *subchildren;
	char    *cptr;

	if (!str) return(NULL);
	for (int i = 0; i < nchildren; i++) {
		item = (GtkWidget *) g_list_nth_data(children,i);
		subchildren = gtk_container_children((GtkContainer *) item);
		item2 = (GtkWidget *) g_list_nth_data(subchildren,0);
		gtk_label_get(GTK_LABEL(item2),&cptr);
		/*
		 *	Success!
		 */
		if (!strcmp(str,cptr)) {
			GtkMenuItem *gmi = (GtkMenuItem *) item;
#ifdef	notdef
			fprintf(stderr,"found menu 0x%08x/%s %s 0x%08x\n",
				item,str,gtk_widget_get_name(item),gmi->submenu);
#endif	/*notdef*/
			return(gmi->submenu);
		}
	}
	if (add_if_not_found) {
		GtkWidget *newW = gsAddMainMenuItem(str);
		return(newW);
	}
	return(NULL);
}

GtkWidget *
gsAddMainMenuItem(char *str)
{
	int help = gsFindMainMenuItemLocation("Help");

	GtkWidget *new_menu = gtk_menu_item_new_with_label(str);
	GtkWidget *submenu = gtk_menu_new();

	gtk_menu_item_set_submenu((GtkMenuItem *) new_menu,submenu);

	gtk_widget_show(submenu);
	gtk_widget_show(new_menu);
	if (help < 0) {
		gtk_menu_bar_append((GtkMenuBar *) theRootMenuBar,new_menu);
	}
	else	{
		gtk_menu_bar_insert((GtkMenuBar *) theRootMenuBar,new_menu,help);
	}
	return(submenu);
}
