/*
 * Copyright (C) 1999 Silicon Graphics, Inc.  All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  Further, any license provided herein,
 * whether implied or otherwise, is limited to this program in accordance
 * with the express provisions of the GNU General Public License.  Patent
 * licenses, if any, provided herein do not apply to combinations of this
 * program with other product or programs, or any other product whatsoever.
 * This program is distributed without any warranty that the program is
 * delivered free of the rightful claim of any third person by way of
 * infringement or the like.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 */

#include "Gessie.h"
#include "Wobject.h"
#include <string.h>

gboolean
gsMovePanel(Panel *src,PanelContainer *to)
{
        GtkWidget       *child = src->baseWidget();
        char            *label = src->getLabel();

	PanelContainer *from = (PanelContainer *) gsSearchPanelsUpward(src,
							"PanelContainer");
        /*
         *      Locate and nuke previous instance meta info
         */
//	PanelContainer *homepc = (PanelContainer *) src->getParent();
        if (from == to) {       // dropped in same panel container
                return(TRUE);
        }
        assert(from != NULL);
        gint    pNum = gtk_notebook_page_num(GTK_NOTEBOOK(from->baseWidget()),
                                             child);
        gtk_widget_ref(child);
        gtk_notebook_remove_page(GTK_NOTEBOOK(from->baseWidget()),pNum);

        /*
         *      Add it to the dropped panel container
         */
        to->add(src,label);
        gtk_widget_unref(child);
        return(TRUE);
}

/*
 *	From a user specified panel, find the toplevel panelcontainer.
 */

Wobject *
gsFindTopLevel(Panel *p)
{
	if (p == NULL) return(NULL);
	for (Wobject *w = (Wobject *) p; 
	     w->getParent() != NULL; 
	     w = (Wobject *) w->getParent());
}

Wobject *
gsSearchPanelsUpward(Panel *p,char *name)
{
	Wobject *w;

	if (p == NULL) return(NULL);
//	fprintf(stderr,"looking up \"%s\" [0x%06x][0x%06x]\n",name,p,p->getParent());
	for (w = (Wobject *) p; w != NULL; w = (Wobject *) w->getParent()) {
//		fprintf(stderr,"0x%08x  w->typeName=%s\n",w,w->typeName());
		if (!strcmp(w->typeName(),name)) {
//			fprintf(stderr,"found my top level!\n");
			return(w);
		}
	}
	return(NULL);
}


