/*
 * Copyright (C) 1999 Silicon Graphics, Inc.  All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  Further, any license provided herein,
 * whether implied or otherwise, is limited to this program in accordance
 * with the express provisions of the GNU General Public License.  Patent
 * licenses, if any, provided herein do not apply to combinations of this
 * program with other product or programs, or any other product whatsoever.
 * This program is distributed without any warranty that the program is
 * delivered free of the rightful claim of any third person by way of
 * infringement or the like.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 */

#ifndef	TOOLBAR_H
#define	TOOLBAR_H
#include "Wobject.h"

class ToolBar : public Wobject {
public:
	ToolBar() {
		theBaseWidget = gtk_toolbar_new(GTK_ORIENTATION_HORIZONTAL,
						GTK_TOOLBAR_BOTH);
		show();
	}
	gchar	*name()			{ return("ToolBar");	}
	GtkWidget	*add(const char *str,GtkWidget *icon,
			     GtkSignalFunc func = (GtkSignalFunc) NULL,
			     gpointer client_data = (gpointer) NULL) {
		GtkWidget *tmp = gtk_toolbar_append_item(
					(GtkToolbar *)  theBaseWidget,str,
                                        (const char *)  NULL, str, icon, func,
                                        client_data);
//		gtk_container_set_border_width(GTK_CONTAINER(icon), 0);
//		gtk_container_set_border_width(GTK_CONTAINER(tmp) , 0);
		gtk_widget_show(tmp);
		return(tmp);
	}
	void	addSpace() {
		gtk_toolbar_append_space(GTK_TOOLBAR(theBaseWidget));
	}
};
#endif	/*TOOLBAR_H*/
