/*
 * Copyright (C) 1999 Silicon Graphics, Inc.  All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  Further, any license provided herein,
 * whether implied or otherwise, is limited to this program in accordance
 * with the express provisions of the GNU General Public License.  Patent
 * licenses, if any, provided herein do not apply to combinations of this
 * program with other product or programs, or any other product whatsoever.
 * This program is distributed without any warranty that the program is
 * delivered free of the rightful claim of any third person by way of
 * infringement or the like.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 */

#include <gtk/gtk.h>
#include "Globals.h"

GtkWidget	*_gsMI = NULL;

void
_gsUnselect(GtkWidget *w,gchar *)
{
	gtk_item_deselect((GtkItem *) w);
}

GtkWidget	*getIcon(gchar **data)
{
        GtkStyle *style;
        GdkPixmap *pixmap;
        GdkBitmap *mask;
	GtkWidget	*tmp;

        style = gtk_widget_get_style(theRootWindow);
        pixmap = gdk_pixmap_create_from_xpm_d(theRootWindow->window,  &mask,
                                              &style->bg[GTK_STATE_NORMAL],
                                              data);
        tmp = gtk_pixmap_new(pixmap, mask);
        gtk_widget_show(tmp);
	return(tmp);
}

GtkWidget *initMainMenus(int cnt,GtkItemFactoryEntry menu_items[])
{
	GtkAccelGroup *acgroup = gtk_accel_group_new ();
  	GtkItemFactory *item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR,
							    "<main>",acgroup);
	gtk_item_factory_create_items (item_factory, cnt, menu_items, NULL);
       	/* Attach the new accelerator group to the window. */
	gtk_accel_group_attach(acgroup, GTK_OBJECT (theRootWindow));
	GtkWidget *tmp = gtk_item_factory_get_widget (item_factory, "<main>");
	gtk_widget_show(tmp);
	return(tmp);
}


void
gsSetBusyCursor(GtkWidget *w)
{
	static GdkCursor *watch_cursor = NULL;
        if (watch_cursor == NULL) {
                watch_cursor = gdk_cursor_new(GDK_WATCH);
        }
        gdk_window_set_cursor ((w == NULL) ? theRootWindow->window
                                	   : w->window, 
				watch_cursor);
	while (gtk_events_pending()) gtk_main_iteration();
}

void
gsUnsetBusyCursor(GtkWidget *w)
{
        gdk_window_set_cursor ((w == NULL) ? theRootWindow->window
                                	   : w->window, 
				NULL);
	while (gtk_events_pending()) gtk_main_iteration();
}
