/*
 * Copyright (C) 1999 Silicon Graphics, Inc.  All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  Further, any license provided herein,
 * whether implied or otherwise, is limited to this program in accordance
 * with the express provisions of the GNU General Public License.  Patent
 * licenses, if any, provided herein do not apply to combinations of this
 * program with other product or programs, or any other product whatsoever.
 * This program is distributed without any warranty that the program is
 * delivered free of the rightful claim of any third person by way of
 * infringement or the like.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 */

#ifndef	WOBJECT_H
#define	WOBJECT_H

#include <gtk/gtk.h>

extern void addPanelToBrokerList(void *);
extern void removePanelFromBrokerList(void *);

class Wobject {
protected:
	GtkWidget	*theBaseWidget;
	GtkWidget	*theContentWidget;
	void		*parent;	// generic for little good reason
public:
	Wobject() {
	}
	GtkWidget	*baseWidget()	{ return(theBaseWidget);	  }
	GtkWidget	*contentWidget(){ return(theContentWidget);	  }
	void		show()		{ gtk_widget_show(theBaseWidget); }
	virtual gchar	*name()		{ return("Wobject");		  }
	virtual gchar	*typeName()	{ return("Wobject");		  }
	virtual int	interested(char * /*msgtype*/,gpointer /*data*/) { return(-1); }
	void		setSizes(int w,int h) {
					gtk_widget_set_usize(theBaseWidget, 
							     (gint) w,(gint) h);
	}
	void	setParent(void *p)	{ parent = p; addPanelToBrokerList((void *) this); 		}
	void	*getParent()		{ return(parent);	}  
};

#endif	/*WOBJECT_H*/
